var $ = jQuery;
$(function() {
	var URL = (window.location.href).split('/');
	var DisciplineID = URL[URL.length - 1]
	
	// Для сохранения изменений
	// Только для элементов, которые были созданы до текущей сессии изменений
	var ChangeData = [];

	// Проверка на число, причем NaN не помеха
	function isNum(v) {
			return typeof v === 'number' && isFinite(v);
	} 

	// Шаблон мероприятия
	function GetSubModuleTmp(){
		return '\
		<div class="subModule">\
			<div class="name">\
				<input type="text" class="inputName" value="Наименование мероприятия">\
			</div>\
			<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value=""></div>\
			<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value=""></div>\
			<div class="actions">\
				<div class="deleteSubModule delete"></div>\
				<div class="downSubModule down"></div>\
				<div class="upSubModule up"></div>\
			</div>\
		</div>\
		';
	}
	
	// Шаблон модуля
	function GetModuleTmp() {
		return '\
		<div class="moduleGroup">\
			<div class="moduleHead">\
				<div class="name">\
					<input type="text" class="inputName" value="Наименование модуля">\
				</div>\
				<div class="currentControl">0</div>\
				<div class="landmarkControl">0</div>\
				<div class="actions">\
					<div class="deleteModule delete"></div>\
					<div class="downModule down"></div>\
					<div class="upModule up"></div>\
					<div class="addSubModule add"></div>\
				</div>\
			</div>\
			<div class="subModules">\
			'+GetSubModuleTmp()+'\
			</div>\
		</div>'
	};
	
	// Основная функция изменения расположения модулей
	// Тут собственно происходит запись во временный массив
	function ChangeModuleOrderInTMPData(ID, NewOrder) {
		// Добавление во временный массив
		if (Array.isArray(ChangeData[ID]) == false)
			ChangeData[ID] = [];
		ChangeData[ID]['Order'] = NewOrder;
	}
	
	// Вспомогательная функция изменения расположения МОДУЛЯ
	function ChangeModuleOrder(thisDIV) {
        var parentDIV = thisDIV.parent('div').parent('div').parent('div');

		// Запоминаем расположение МОДУЛЯ, на который нажали
		var NewOrder = $('.moduleGroup').index(parentDIV) + 1;
		var ID = parentDIV.attr('id');
		// Добавление во временный массив
		ChangeModuleOrderInTMPData(ID, NewOrder);
		
		return NewOrder;
	}
	
	// Основная функция изменения расположения мероприятий
	// Тут собственно происходит запись во временный массив
	function ChangeSubmoduleOrderInTMPData(ModuleID, SubmoduleID, NewOrder) {
		// Добавление во временний массив
		if (Array.isArray(ChangeData[ModuleID]) == false)
			ChangeData[ModuleID] = [];
		if (Array.isArray(ChangeData[ModuleID][SubmoduleID]) == false)
			ChangeData[ModuleID][SubmoduleID] = [];
		ChangeData[ModuleID][SubmoduleID]['Order'] = NewOrder;
	}
	// Вспомогательная функция изменения расположения МЕРОПРИЯТИЯ
	function ChangeSubmoduleOrder(thisDIV) {
		var parentDIV = thisDIV.parent('div').parent('div');
		
		// Запоминаем расположение МОДУЛЯ, на который нажали
		var NewOrder = $('.subModule', parentDIV.parent('div')).index(parentDIV) + 1;
		var ModuleID = parentDIV.parent('div').parent('div').attr('id');
		var SubmoduleID = parentDIV.attr('id');
		// Добавление во временный массив
		ChangeSubmoduleOrderInTMPData(ModuleID, SubmoduleID, NewOrder);
		
		return NewOrder;
	}
	
	// Подсчет текущего контроля
	function CountCurrentControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputCurrentControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0);
		});
		subModulesDiv.prev().children('.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputLandmarkControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('.landmarkControl').text(maxCredits);
	}
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var parentDIV = $(this).parent('div').parent('div').parent('div');
        parentDIV.insertBefore(parentDIV.prev());
		var NewOrder = ChangeModuleOrder($(this));
		
		// Для того, который СТАЛ находится ниже
		var nextModuleID = parentDIV.next('div').attr('id');
		var nextNewOrder = NewOrder + 1; // +1 ибо след. див ниже
		ChangeModuleOrderInTMPData(nextModuleID, nextNewOrder);
		
        return false
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var parentDIV = $(this).parent('div').parent('div').parent('div');
        parentDIV.insertAfter(parentDIV.next());
		var NewOrder = ChangeModuleOrder($(this));
		
		// Для того, который СТАЛ находится выше
		var prevModuleID = parentDIV.prev('div').attr('id');
		var prevNewOrder = NewOrder - 1; // -1 ибо пред. див выше
		ChangeModuleOrderInTMPData(prevModuleID, prevNewOrder);
		
        return false
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubModule', function(){
        var parentDIV = $(this).parent('div').parent('div');
        parentDIV.insertBefore(parentDIV.prev());
		var NewOrder = ChangeSubmoduleOrder($(this));
		
		var ModuleID = parentDIV.parent('div').parent('div').attr('id');
		var nextSubmoduleID = parentDIV.next('div').attr('id');
		var nextNewOrder = NewOrder + 1;
		ChangeSubmoduleOrderInTMPData(ModuleID, nextSubmoduleID, nextNewOrder);
		
        return false
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubModule', function(){
        var parentDIV = $(this).parent('div').parent('div');
        parentDIV.insertAfter(parentDIV.next());
		var NewOrder = ChangeSubmoduleOrder($(this));
		
		var ModuleID = parentDIV.parent('div').parent('div').attr('id');
		var prevSubmoduleID = parentDIV.prev('div').attr('id');
		var prevNewOrder = NewOrder - 1;
		ChangeSubmoduleOrderInTMPData(ModuleID, prevSubmoduleID, prevNewOrder);
		
        return false
    });
	
	// Добавить модуль
	$('.addModule').click(function(){
		$('.moduleList').append(GetModuleTmp());
	});
	
	// Добавить мероприятие
	$('.moduleList').on('click', '.addSubModule', function(){
		$(this).parent().parent().next().append(GetSubModuleTmp());
	});
	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent('div').parent('div').parent('div').remove();
		var ID = $(this).parent('div').parent('div').parent('div').attr('id');
		// Удаление из временного массива
		if (Array.isArray(ChangeData[ID]))
			ChangeData.splice(ChangeData.indexOf(ID), 1);
	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubModule ', function(){
		var ModuleID = $(this).parent('div').parent('div').parent('div').parent('div').attr('id');
		var SubmoduleID = $(this).parent('div').parent('div').attr('id');
		var subModulesDiv = $(this).parent().parent().parent();
		$(this).parent('div').parent('div').remove();
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
		if (Array.isArray(ChangeData[ModuleID][SubmoduleID]))
			ChangeData[ModuleID].splice(ChangeData[ModuleID].indexOf(SubmoduleID), 1);
	});
	
	// Поменять название модуля
	var ModuleName;
	$('.ModuleName').focusin(function(){
		ModuleName = $(this).val();
	});
	$('.ModuleName').focusout(function(){
		var NewModuleName = $(this).val();
		if (NewModuleName != '' && ModuleName != NewModuleName) {
			var ID = $(this).parent('div').parent('div').parent('div').attr('id');
			// Добавление во временний массив
			if (Array.isArray(ChangeData[ID]) == false)
				ChangeData[ID] = [];
			ChangeData[ID]['ModuleName'] = NewModuleName;
		}
	});
	
	// Поменять название мероприятие
	var SubmoduleName;
	$('.SubmoduleName').focusin(function(){
		SubmoduleName = $(this).val();
	});
	$('.SubmoduleName').focusout(function(){
		var NewSubmoduleName = $(this).val();
		if (NewSubmoduleName != '' && SubmoduleName != NewSubmoduleName) {
			var ModuleID = $(this).parent('div').parent('div').parent('div').parent('div').attr('id');
			var SubmoduleID = $(this).parent('div').parent('div').attr('id');
			// Добавление во временний массив
			if (Array.isArray(ChangeData[ModuleID]) == false)
				ChangeData[ModuleID] = [];
			if (Array.isArray(ChangeData[ModuleID][SubmoduleID]) == false)
				ChangeData[ModuleID][SubmoduleID] = [];
			ChangeData[ModuleID][SubmoduleID]['SubmoduleName'] = NewSubmoduleName;
		}
	});
	
	// При записи в input текущий контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputCurrentControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputCurrentControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountCurrentControl(subModulesDiv);
		if (parseInt($(this).val()) > 0 )
			// Блокируем рубежный контроль
			$(this).parent().parent().children('.landmarkControl').children('.inputLandmarkControl').attr('readonly', true);
		else 
			$(this).parent().parent().children('.landmarkControl').children('.inputLandmarkControl').attr('readonly', false);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputLandmarkControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputLandmarkControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountLandmarkControl(subModulesDiv);
		if (parseInt($(this).val()) > 0 )
			// Блокируем рубежный контроль
			$(this).parent().parent().children('.currentControl').children('.inputCurrentControl').attr('readonly', true);
		else 
			$(this).parent().parent().children('.currentControl').children('.inputCurrentControl').attr('readonly', false);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$(".moduleList").on('keydown', '.inputCredit', function(event) {
        // Разрешаем: backspace, delete, tab и escape
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || 
             // Разрешаем: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) || 
             // Разрешаем: home, end, влево, вправо
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // Ничего не делаем
                 return;
        }
        else {
            // Убеждаемся, что это цифра, и останавливаем событие keypress
            if ((event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault(); 
            }   
        }
    });
	
	// При нажатие кнопки 'сохранить' генерация JSON
	$('.createStudyMap').click(function(){
		var modulesCount = 0;
		// jsonModules - JSON данные, для отправки на сервер
		var jsonModules = '{"DisciplineID" : "'+DisciplineID+'", ';
		var amountModulesHead = $('.moduleGroup').size();
		$('.moduleGroup').each(function(i){
			modulesCount++;
			var subModulesCount = 0;
			jsonModules += '"'+i+'"'+':{';
			var jsonModule = '"moduleName":"'+$(this).children('.moduleHead').children('.name').children('.inputName').val()+'",';
			// jsonSubModules - мероприятия в JSON представление
			var jsonSubModules = '"subModules":{';
			var amountSubModules = $('.subModule', this).size();
			$('.subModule', this).each(function(i){
				subModulesCount++;
				var subModuleName = $(this).children('.name').children('.inputName').val();
				
				var rateControl; // Тип контроля
				if (parseInt($(this).children('.currentControl').children('.inputCurrentControl').val()) > 0)
					rateControl = '"maxRate" : "'+parseInt($(this).children('.currentControl').children('.inputCurrentControl').val())+'", "typeControl" : "CurrentControl"';
				if (parseInt($(this).children('.landmarkControl').children('.inputLandmarkControl').val()) > 0)
					rateControl = '"maxRate" : "'+parseInt($(this).children('.landmarkControl').children('.inputLandmarkControl').val())+'", "typeControl" : "LandmarkControl"';
				
				jsonSubModules += '"'+i+'":{"subModuleName":"'+subModuleName+'", '+rateControl+'}';
				jsonSubModules += (i + 1 == amountSubModules) ? '' : ',';
			});
			jsonSubModules += ', "subModulesCount" : "'+subModulesCount+'"}';
			jsonModules += jsonModule+jsonSubModules;
			jsonModules += (i + 1 == amountModulesHead) ? '}' : '},';
		});
		jsonModules += ', "modulesCount" : "'+modulesCount+'" }';
		console.log(JSON.stringify(jsonModules));
		
		$.post(
			'/~dev_rating/handler/map/AddMap',
			{"data" : jsonModules},
			function(data){
				alert(data);
			},
			'json'
		);
	});

	/*
	// При нажатие кнопки 'сохранить' генерация JSON
	$('.saveStudyMap').click(function(){
		// jsonModules - JSON данные, для отправки на сервер
		var jsonModules = "{";
		var amountModulesHead = $('.moduleGroup').size();
		$('.moduleGroup').each(function(i){
			jsonModules += '"'+i+'"'+':{';
			var jsonModule = '"moduleHead": {"moduleName":"'+$(this).children('.moduleHead').children('.name').children('.inputName').val()+'", "id":"id/hash here", "currentControl":"'+$(this).children('.moduleHead').children('.currentControl').text()+'", "landmarkControl":"'+$(this).children('.moduleHead').children('.landmarkControl').text()+'"},';
			// jsonSubModules - мероприятия в JSON представление
			var jsonSubModules = '"subModules":{';
			var amountSubModules = $('.subModule', this).size();
			$('.subModule', this).each(function(i){
				var subModuleName = $(this).children('.name').children('.inputName').val();
				jsonSubModules += '"'+i+'":{"subModuleName":"'+subModuleName+'","id":"id/hash here"}';
				jsonSubModules += (i + 1 == amountSubModules) ? '' : ',';
			});
			jsonSubModules += '}';
			jsonModules += jsonModule+jsonSubModules;
			jsonModules += (i + 1 == amountModulesHead) ? '}' : '},';
			//console.log(JSON.stringify('{'+jsonModule+jsonSubModules+'}'));
		});
		jsonModules += "}";
		console.log(JSON.stringify(jsonModules));
		
		$.post(
			'/~dev_rating/handler/map/AddMap',
			{"data" : jsonModules},
			function(data){
				alert(data);
			},
			'json'
		);
	});
	*/
	
	$('.change').click(function(){
		console.log(ChangeData);
	});
});
